/*
   DISKCOPY.EXE, floppy diskette duplicator similar to MSDOS Diskcopy.
   Copyright (C) 1998, Matthew Stanford.
   Copyright (C) 1999, 2000, 2001 Imre Leber.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have recieved a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


   If you have any questions, comments, suggestions, or fixes please
   email me at: imre.leber@worldonline.be

 */

#ifndef FASTCOPY_H_
#define FASTCOPY_H_

#define FULL 11
#define FAST 22

#define FAT12  12
#define FAT16  16
#define FAT32  32

int DiskReadFatInfo (int drive);
int FileReadFatInfo (char *file);

void SetCopySpeed (int method);
int IsDiskReadRequired (unsigned long beginsector, int amount);
void ReleaseFatInfo (void);
int DiskReadBootInfo (int drive, struct dfree *free);
int FileReadBootInfo (char *file, struct dfree *free);

unsigned long GetDiskFilledSize (unsigned blocksize);


int IsSectorUsed (unsigned long sector);

int DetermineFATType(void);

#endif